<project xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xmlns="http://maven.apache.org/POM/4.0.0"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
  <modelVersion>4.0.0</modelVersion>
  <groupId>com.partisiablockchain.blockchain.api</groupId>
  <artifactId>transaction-client</artifactId>
  <packaging>jar</packaging>

  <parent>
    <groupId>com.partisiablockchain.core</groupId>
    <artifactId>server-parent</artifactId>
    <version>5.102.0</version>
    <relativePath>../pom.xml</relativePath>
  </parent>

  <dependencies>
    <dependency>
      <groupId>com.partisiablockchain.core</groupId>
      <artifactId>contract</artifactId>
      <version>5.32.0</version>
    </dependency>
    <dependency>
      <groupId>jakarta.annotation</groupId>
      <artifactId>jakarta.annotation-api</artifactId>
    </dependency>
    <dependency>
      <groupId>com.fasterxml.jackson.core</groupId>
      <artifactId>jackson-annotations</artifactId>
    </dependency>
    <dependency>
      <groupId>com.fasterxml.jackson.core</groupId>
      <artifactId>jackson-databind</artifactId>
    </dependency>
    <dependency>
      <groupId>com.fasterxml.jackson.datatype</groupId>
      <artifactId>jackson-datatype-jsr310</artifactId>
    </dependency>
    <dependency>
      <groupId>org.glassfish.jersey.containers</groupId>
      <artifactId>jersey-container-jdk-http</artifactId>
    </dependency>
    <dependency>
      <groupId>org.glassfish.jersey.media</groupId>
      <artifactId>jersey-media-json-jackson</artifactId>
    </dependency>
    <dependency>
      <groupId>org.glassfish.jersey.media</groupId>
      <artifactId>jersey-media-multipart</artifactId>
    </dependency>
    <dependency>
      <groupId>org.mockito</groupId>
      <artifactId>mockito-core</artifactId>
      <scope>test</scope>
    </dependency>
  </dependencies>

  <build>
    <plugins>
      <plugin>
        <groupId>org.openapitools</groupId>
        <artifactId>openapi-generator-maven-plugin</artifactId>

        <executions>
          <execution>
            <id>java</id>
            <goals>
              <goal>generate</goal>
            </goals>
            <configuration>
              <inputSpec>${project.basedir}/../server/src/main/resources/openapi.json</inputSpec>
              <generatorName>java</generatorName>
              <templateDirectory>${project.basedir}/templates</templateDirectory>

              <invokerPackage>com.partisiablockchain.api.transactionclient.utils</invokerPackage>

              <apiPackage>com.partisiablockchain.api.transactionclient.api</apiPackage>
              <generateApiTests>false</generateApiTests>
              <generateApiDocumentation>false</generateApiDocumentation>

              <modelPackage>com.partisiablockchain.api.transactionclient.model</modelPackage>
              <generateModelTests>false</generateModelTests>
              <generateModelDocumentation>false</generateModelDocumentation>

              <configOptions>
                <library>jersey3</library>
                <serializationLibrary>jackson</serializationLibrary>
                <useJakartaEe>true</useJakartaEe>
                <openApiNullable>false</openApiNullable>
                <supportUrlQuery>false</supportUrlQuery>
                <useBeanValidation>false</useBeanValidation>
                <additionalEnumTypeAnnotations>@com.partisiablockchain.api.transactionclient.Generated()</additionalEnumTypeAnnotations>
              </configOptions>
              <ignoreFileOverride>${project.basedir}/../server/.openapi-generator-ignore</ignoreFileOverride>
              <schemaMappings>
                BlockchainAddress=com.partisiablockchain.BlockchainAddress,
                Hash=com.partisiablockchain.crypto.Hash,
                JsonNode=com.fasterxml.jackson.databind.JsonNode,
              </schemaMappings>
              <importMappings>
                Response=jakarta.ws.rs.core.Response,
              </importMappings>
            </configuration>
          </execution>
          <execution>
            <id>typescript</id>
            <goals>
              <goal>generate</goal>
            </goals>
            <configuration>
              <inputSpec>${project.basedir}/../server/src/main/resources/openapi.json</inputSpec>
              <generatorName>typescript-fetch</generatorName>
              <output>${project.basedir}/../../ts/src/main/generated/openapi</output>
              <generateModelTests>false</generateModelTests>
              <generateModelDocumentation>false</generateModelDocumentation>
            </configuration>
          </execution>
        </executions>
      </plugin>
      <plugin>
        <groupId>org.jacoco</groupId>
        <artifactId>jacoco-maven-plugin</artifactId>
        <configuration>
          <excludes>
            <exclude>**/com/partisiablockchain/api/transactionclient/api/*</exclude>
            <exclude>**/com/partisiablockchain/api/transactionclient/utils/*</exclude>
          </excludes>
        </configuration>
      </plugin>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-javadoc-plugin</artifactId>
        <configuration>
          <excludePackageNames>
            com.partisiablockchain.api.transactionclient.api;
            com.partisiablockchain.api.transactionclient.model;
            com.partisiablockchain.api.transactionclient.utils;
            com.partisiablockchain.api.transactionclient.utils.auth;
          </excludePackageNames>
        </configuration>
        </plugin>
    </plugins>
  </build>

</project>
